/***

The MIT License

Copyright (c) 2018 Teppei Tamra (TAM)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

***/

#ifndef SAORIACCOUNT_H
#define SAORIACCOUNT_H

#include <QObject>
#include <QList>
#include <saoridon.h>
#include <QJsonDocument>
#include <QJsonObject>
#include <QNetworkAccessManager>
#include <QNetworkReply>

class SaoriAccount : public QObject
{
    Q_OBJECT
    Q_PROPERTY(QString name READ name WRITE setName)
    Q_PROPERTY(QString accessToken READ accessToken WRITE setAccessToken NOTIFY accessTokenChanged)

public:
    explicit SaoriAccount(const QString accountName, Saoridon *instance, const QString accsessToken, QObject *parent = nullptr);
    const QString accessToken();
    void setAccessToken(QString token);
    const QString name();
    void setName(const QString name);
    Saoridon *instance();
    const QString accountInfo(const QString key);
    const QStringList timelineList();

protected:
    void getAccountInfomation();
    QNetworkRequest createHearder();
    void requestGET(QUrl url,QNetworkAccessManager *manager);

protected:
    QString m_name;
    QString m_accessToken;
    Saoridon *m_instance;
    QMap<QString,QString> m_accountInfo;

signals:
    void accessTokenChanged(QString);
    void accountInfomationChanged();

public slots:
};

#endif // SAORIACCOUNT_H
